
 <meta name="twitter:image:src" content="https://repository-images.githubusercontent.com/307118850/926c7980-16e0-11eb-853b-4701d7259e4d" /><meta name="twitter:site" content="@github" /><meta name="twitter:card" content="summary_large_image" /><meta name="twitter:title" content="TENEIDAE/Roblox-Clone-Tutorial" /><meta name="twitter:description" content="LEARN TO MAKE A LEGO SITE! Contribute to TENEIDAE/Roblox-Clone-Tutorial development by creating an account on GitHub." />
<meta property="og:image" content="https://repository-images.githubusercontent.com/307118850/926c7980-16e0-11eb-853b-4701d7259e4d" /><meta property="og:site_name" content="GitHub" />
<meta property="og:type" content="object" /><meta property="og:title" content="TENEIDAE/Roblox-Clone-Tutorial" /><meta property="og:url" content="https://github.com/TENEIDAE/Roblox-Clone-Tutorial" /><meta property="og:description" content="LEARN TO MAKE A LEGO SITE! Contribute to TENEIDAE/Roblox-Clone-Tutorial development by creating an account on GitHub." />
# How to make a sandbox game

ROBLOX clones have gotten pretty popular in the last years. Leading to many people wanting to know: How do I make one?

Lets start easy: **You're asking yourself how to basically make Roblox. Expect it to be kind of hard to make.**

First of all we want to know what we need to know:

1. You cant make a ROBLOX clone overnight. Making a website with backend, database, authentication, 3D rendering and maintaning proper website security for thousands of users while having a very small team of developers is not a easy task.
2. You need to know programming to some extent, or be good at finding people willing to work for you.
3. You need a stable income from external sources. ROBLOX clones **are not profitable**. Only ROBLOX or very big clones, such as Brick-Hill, can use their very own income as payment.
4. ROBLOX clones do not last.

### Roadmap.

We need things as clear as possible, so this is going to be our roadmap:

#### Make the site.

#### Look for hosting.

#### Test the site security.

#### Hire the staff.

#### Launch it to the public.

If we don't follow this order, there's a high chance you will fail at making the clone.

### Making the site.

The site is the most important part of a Roblox clone, it's what makes it different. If you know web development you can do it yourself, else you will need to hire staff. That asides: NEVER and i repeat, NEVER ever promote a community that is not built. It will end up horrible.

#### I know web development.

When talking about web development, we talk about backend services primarily. Services such as Wix, Google Sites, Weebly or 000webhost **cant be used to make a sandbox site.**

When talking about web development we talk about programming languages and frameworks. Here's a list of **the best frameworks and languages to make your Roblox clone on!**

| Language            | Framework           | Score |
| ------------------- | ------------------- | ----- |
| JavaScript (NodeJS) | Express v4          | 9/10  |
| Python              | Flask, Django       | 6/10  |
| Ruby                | Ruby on rails.      | 9/10  |
| Java                | Spring              | 3/10  |
| C#                  | ASP.net + Azure     | 5/10  |
| PHP                 | Laravel / Plain PHP | 9/10  |

If you're wondering why C# and Java have such low scoring, it's due to the complexity of making maintainable code on Java and C# for web. It's kind of **overengineering web development**. That's why JavaScript or Ruby received a better score. They are easily maintainable, portable and lightweight.

Python score is also low, it's not because it's hard to maintain, but because its really hard to get started on web development with python. It is not very flexible and requires quite a good amount of Object Oriented Programming (OOP) in Python. That asides their frameworks are not the fastest (Except Django, which is instant)

##### Personal recommendations:

PHP and JavaScript are the best to get started. They are the most used and offer support for most needs.

Ruby is also good to get started, but it's not widely used in sandbox development.

##### Databases

You need a database that works with you. Depending on your backend you can decide whether use NoSQL or SQL databases. Here's a list with the databases I know:

| Name       | Type               |
| ---------- | ------------------ |
| MongoDB    | NoSQL & JSON       |
| Oracle 12c | Grid               |
| MySQL      | SQL                |
| PostgreSQL | SQL & JSON         |
| REDIS      | NOSQL              |
| MariaDB    | SQL                |
| DB2        | JSON & XML & NOSQL |
| Cassandra  | CQL                |
| Oracle     | SQL & PL           |



#### I don't know web development.

Then you need staff, good staff. Finding good staff is really hard nowadays. There's really a big amount of people that fake being developers just to look good on ROBLOX clones. So you'll need a good amount of questions to make when looking for them. 

How do I get started looking for them? 

A good way is to ask on forums or join web dev communities. For the last option it would be recommended to have more of a professional looking offer as many of them are +15.

If you don't know what to say then you can use this template i made:

```
Hello everyone! My name is ____. Im currently looking for web developers experienced in || Language you had choosen for the backend || and that know how to work with || database you selected ||. 
```

However, developers need one thing to work, and that's money. If you don't think you can hire developers for the price they're offerring, you should learn programming.

If you're still unsure you can spend most of your time thinking.

#### Hosting.
Yes, hosting. This is where most clones also die. They want to make a ROBLOX clone and realize they need a host. If your site runs on PHP you can be lucky because there's some free hosts out there, but they dont really like the idea of letting you save anything to their harddrives. + Shell is not supported most of the times.

Looking for a good host can be a pain in the ass (VPS). So here at Teneidae we made a whole pricing table with the best options. Thanks us later~ 

##### VPS Pricing

| Provider Name    | Cheapest VPS Price | HDD        | CPU Speed | Ram | Most Expensive VPS Price | HDD         | CPU Speed | Ram | Final Score |
|------------------|--------------------|------------|-----------|-----|--------------------------|-------------|-----------|-----|-------------|
| nodeclusters.com | 4$ / Month         | 200GB      | 1VCore    | 1GB | 12$ / Month              | 600GB       | 1Vcore    | 2GB | 8/10        |
| Bluehost.com     | 19$ / Month        | 30GB (SSD) | 2Vcores   | 2GB | 59.9$ / Month            | 120GB (SSD) | 4Vcores   | 8GB | 9/10        |
| Hostinger        | 3$ / Month         | 20GB (SSD) | 1Vcore    | 1GB | 33$ / MOnth              | 160GB (SSD) | 8Vcores   | 8GB | 9/10        |
| iPage            | 20$ / Month        | 40GB (SSD) | 1Vcore    | 1GB | 79$ / Month              | 120GB (SSD) | 4Vcores   | 8GB | 8/10        |
| Hostgator        | 19.95$ / Month     | 120GB      | 2Vcores   | 2GB | 39$ / Month              | 240GB       | 4Vcores   | 8GB | 9/10        |
| DigitalOcean     | 5$ / Month         | 25GB (SSD) | 1Vcore    | 1GB | 2480$ / Month            | 7.03TB (SSD) | 32Vcores | 256GB | 9.5/10    |

---
Alright! Now you have developers, they know what they are going to use for the site, but they dont know anything about what **you** want. As the owner you must take responsability and do all the designs of how more less you want the site to look like. Make a good description explaining how you want everything work, and **never ever** say no to an engineer opinion. If they tell you something cant be done then be constructive and learn why.

#### Some more tips:
Dont use open sourced clones or any leaked source. Sites like Thamur, Retrimo and Vertineer use all the same source code, which makes them completely effortless.

Even if it's "temporary" you shouldnt use them. Dont make a "temporary" site just because you want a community so bad. A good community takes time to grow, but it solely starts from the developer. Create a good and unique website, advertise, it will both make and help your community grow.

#### Gaining Members.

Many ROBLOX clones allow partnerships with other clones, join some and promote your site by contacting the person in charge of the partnerships. Remember to act professionally and serious. Dont get too excited.

#### Site rollout. 

Your ROBLOX clone is out and functioning fine.



